<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <title>Document</title>
    <style type="text/css">
    *{
    	margin:0px;
    	padding: 0px;
    }

    .salida {
        border: 1px solid blue;
        background-color: #ccc;
        width: 500px;
        margin: 10px auto;
        padding: 5px;
        height: 100px;
        line-height: 100px;
    }

    form {
        width: 500px;
        margin: 10px auto;
        padding: 5px;
        background-color: #ccc;
    }

    form * {
        margin: 5px;
    }

	button{
		width:150px;
		line-height: 20px;
	}

    label {
        font-weight: bold;
        text-transform: capitalize;
    }

    .titulo{
    	height:40px;
    	line-height: 40px;
    }
    </style>
    <script type="text/javascript">
    /* defino variables globales */
    var vector = [];
    /* fin de variables globales */

    function mostrar(vector,objeto) {
        var salida = document.querySelector("#" + objeto); //creo esta variable para indicar que la variable salida accede a la id del objeto.

        salida.innerHTML = vector.join(",");//join es una propiedad del array que coje un array y escribe en string separado en este caso por una coma
    }

    function introducir() {
    	var vacio=[""];
        //vamos a utilizar el vector global
        introduce(vector);// llamamos a la funcion introduce
        mostrar(vector,"original");
        mostrar(vacio,"ordenado");
        mostrar(vacio,"media");
        mostrar(vacio,"moda");
        mostrar(vacio,"mediana");
        mostrar(vacio,"maximo");
        mostrar(vacio,"minimo");
    }

    function introduce(vector) { 
        var caja = document.querySelector("#numero");//si aqui ponemos .value ya no podriamos acceder al elemento solo accedemos al valor.

        vector.push(parseInt(caja.value));//.value es para recibir los datos y el innerHTML da valor a un elemento.
    }

    function ordenar(tipo) {
        var v = [];
        v = copiar(vector)

        // podria hacer una copia de la siguiente forma cuando se trata de numeros v=vector.slice();----> ahora v es la copia exacta de vector sin afectarlo
        if(tipo=="ascendente"){
        	ordenar1(v);
        }else{
        	ordenar2(v);
        }
       
        mostrar(v,"ordenado");
    }

    function ordenar1(vector) {
        vector.sort(function(a, b) {
            return a - b;
        });
    }

    function copiar(vector){
    	var r=[];
    	vector.forEach(function(v,i){
    		r[i]=v;
    	});

    	return r;
    }

    function ordenar2(vector) {
        var c, c1;
        var aux;

        for (c = 0; c < vector.length - 1; c++) {
            for (c1 = c + 1; c1 < vector.length; c1++) {
            	if(vector[c]<vector[c1]){
                	aux = vector[c];
                	vector[c] = vector[c1];
                	vector[c1] = aux;
                }
            }
        }

    }

    function calcularMedia(vector){
    	var r=0;
    	var c=0;
    	vector.forEach(function(v){
    		r+=v;
    		c++;
    	});

    	r/=c;

    	return r;
    }

    function media(){
    	var r=[];
    	r[0]=calcularMedia(vector);
    	mostrar(r,"media");
    }

    function mediana(){
    	var r=[];
    	r[0]=calcularMediana(vector);
    	mostrar(r,"mediana");	
    }

    function calcularMediana(vector){
		var r=0;
    	var v = [];
        v = copiar(vector)
        ordenar1(v);
        if((v.length%2)!=0){
        	r=v[parseInt(v.length/2)];
        }else{
        	r=(v[parseInt(v.length/2)]+v[parseInt(v.length/2)-1])/2;
        }
        return r;
    }


    function moda(){
    	var r=[];
    	calcularModa(vector);
    }

    function calcularModa(a){
    	var r = [];
    	var resultado=[];
    	var copia = [];

    	a.forEach(function(v) {
        	if (typeof(r[v]) == 'undefined') {
            	r[v] = 0;
        	}
        	r[v]++;
    	});

    	
    	copia = copiar(r)
    	rellenar(r);
    	ordenar1(copia);


    }

    function rellenar(vector){
    	var c=0;
    	for(c=0;c<vector.length;c++){
    		if(typeof(vector[c])=="undefined"){
    			vector[c]=0;
    		}
    	}
    }


    function maximo(){
    	var r=[];
    	calcularMaximo(vector);
    }

    function calcularMaximo(vector){
    	var r=[];
    	var v = [];
        v = copiar(vector);
        ordenar2(v);
        r[0]=v[0];
		        
        mostrar(r,"maximo");
    }


    function minimo(){

    }


    
    </script>
</head>

<body>
    <form name="formulario">
        <div>
            <label for="numero">Numero</label>
            <input type="number" min="0" max="100" step="1" required name="numero" id="numero">
        </div>
        <button type="button" onclick="introducir()">Introducir</button>
        <button type="button" onclick="ordenar('ascendente')">Ordenar Ascendente</button>
        <button type="button" onclick="ordenar('descendente')">Ordenar Descendente</button>
        <button type="button" onclick="maximo()">Maximo</button>
        <button type="button" onclick="minimo()">Minimo</button>
        <button type="button" onclick="media()">Media</button>
        <button type="button" onclick="moda()">Moda</button>
        <button type="button" onclick="mediana()">Mediana</button>
    </form>
    <div class="salida titulo">
        <h2>Original</h2>
    </div>
    <div class="salida" id="original">
    </div>
    <div class="salida titulo">
        <h2>Ordenado</h2>
    </div>
    <div class="salida" id="ordenado">
    </div>
    <div class="salida titulo">
        <h2>Maximo</h2>
    </div>
    <div class="salida" id="maximo">
    </div>
    <div class="salida titulo">
        <h2>Minimo</h2>
    </div>
    <div class="salida" id="minimo">
    </div>
    <div class="salida titulo">
        <h2>Media</h2>
    </div>
    <div class="salida" id="media">
    </div>
    <div class="salida titulo">
        <h2>Moda</h2>
    </div>
    <div class="salida" id="moda">
    </div>
    <div class="salida titulo">
        <h2>Mediana</h2>
    </div>
    <div class="salida" id="mediana">
    </div>
</body>

</html>